diff --git a/liboctave/array/CMatrix.cc b/liboctave/array/CMatrix.cc
--- a/liboctave/array/CMatrix.cc
+++ b/liboctave/array/CMatrix.cc
@@ -3619,33 +3619,68 @@ operator * (const ComplexMatrix& a, cons
     return T (nr, nc);
 
 ComplexMatrix
-min (const Complex& c, const ComplexMatrix& m)
+min (const Complex& c, const ComplexMatrix& m, bool includenan)
 {
   octave_idx_type nr = m.rows ();
   octave_idx_type nc = m.columns ();
 
   EMPTY_RETURN_CHECK (ComplexMatrix);
 
+  if (octave::math::isnan (c) && includenan)
+    return ComplexMatrix (nr, nc, c);
+
+  ComplexMatrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = c <= m(i, j) ? c : m(i, j);
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::min (c, m(i, j));
+          }
+    }
+
+  return result;
+}
+
+ComplexMatrix
+min (const ComplexMatrix& m, const Complex& c, bool includenan)
+{
+  if (! octave::math::isnan (c))
+    return min (c, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (ComplexMatrix);
+
   ComplexMatrix result (nr, nc);
 
   for (octave_idx_type j = 0; j < nc; j++)
     for (octave_idx_type i = 0; i < nr; i++)
       {
         octave_quit ();
-        result(i, j) = octave::math::min (c, m(i, j));
+        result(i, j) = octave::math::isnan (m(i, j)) ? m(i, j) : c;
       }
 
   return result;
 }
 
 ComplexMatrix
-min (const ComplexMatrix& m, const Complex& c)
-{
-  return min (c, m);
-}
-
-ComplexMatrix
-min (const ComplexMatrix& a, const ComplexMatrix& b)
+min (const ComplexMatrix& a, const ComplexMatrix& b, bool includenan)
 {
   octave_idx_type nr = a.rows ();
   octave_idx_type nc = a.columns ();
@@ -3658,66 +3693,93 @@ min (const ComplexMatrix& a, const Compl
 
   ComplexMatrix result (nr, nc);
 
-  for (octave_idx_type j = 0; j < nc; j++)
+  if (includenan)
     {
-      bool columns_are_real_only = true;
-      for (octave_idx_type i = 0; i < nr; i++)
-        {
-          octave_quit ();
-          if (octave::math::imag (a(i, j)) != 0.0 || octave::math::imag (b(i, j)) != 0.0)
-            {
-              columns_are_real_only = false;
-              break;
-            }
-        }
-
-      if (columns_are_real_only)
-        {
-          for (octave_idx_type i = 0; i < nr; i++)
-            result(i, j) = octave::math::min (octave::math::real (a(i, j)),
-                                              octave::math::real (b(i, j)));
-        }
-      else
-        {
-          for (octave_idx_type i = 0; i < nr; i++)
-            {
-              octave_quit ();
-              result(i, j) = octave::math::min (a(i, j), b(i, j));
-            }
-        }
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = a(i, j) <= b(i, j) ? a(i, j)
+                           : (octave::math::isnan (a(i, j)) ? a(i, j)
+                              : b(i, j));
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::min (a(i, j), b(i, j));
+          }
     }
 
   return result;
 }
 
 ComplexMatrix
-max (const Complex& c, const ComplexMatrix& m)
+max (const Complex& c, const ComplexMatrix& m, bool includenan)
 {
   octave_idx_type nr = m.rows ();
   octave_idx_type nc = m.columns ();
 
   EMPTY_RETURN_CHECK (ComplexMatrix);
 
+  if (octave::math::isnan (c) && includenan)
+    return ComplexMatrix (nr, nc, c);
+
+  ComplexMatrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = c >= m(i, j) ? c : m(i, j);
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::max (c, m(i, j));
+          }
+    }
+
+  return result;
+}
+
+ComplexMatrix
+max (const ComplexMatrix& m, const Complex& c, bool includenan)
+{
+  if (! octave::math::isnan (c))
+    return max (c, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (ComplexMatrix);
+
   ComplexMatrix result (nr, nc);
 
   for (octave_idx_type j = 0; j < nc; j++)
     for (octave_idx_type i = 0; i < nr; i++)
       {
         octave_quit ();
-        result(i, j) = octave::math::max (c, m(i, j));
+        result(i, j) = octave::math::isnan (m(i, j)) ? m(i, j) : c;
       }
 
   return result;
 }
 
 ComplexMatrix
-max (const ComplexMatrix& m, const Complex& c)
-{
-  return max (c, m);
-}
-
-ComplexMatrix
-max (const ComplexMatrix& a, const ComplexMatrix& b)
+max (const ComplexMatrix& a, const ComplexMatrix& b, bool includenan)
 {
   octave_idx_type nr = a.rows ();
   octave_idx_type nc = a.columns ();
@@ -3730,37 +3792,25 @@ max (const ComplexMatrix& a, const Compl
 
   ComplexMatrix result (nr, nc);
 
-  for (octave_idx_type j = 0; j < nc; j++)
+  if (includenan)
     {
-      bool columns_are_real_only = true;
-      for (octave_idx_type i = 0; i < nr; i++)
-        {
-          octave_quit ();
-          if (octave::math::imag (a(i, j)) != 0.0 || octave::math::imag (b(i, j)) != 0.0)
-            {
-              columns_are_real_only = false;
-              break;
-            }
-        }
-
-      // FIXME: is it so much faster?
-      if (columns_are_real_only)
-        {
-          for (octave_idx_type i = 0; i < nr; i++)
-            {
-              octave_quit ();
-              result(i, j) = octave::math::max (octave::math::real (a(i, j)),
-                                                octave::math::real (b(i, j)));
-            }
-        }
-      else
-        {
-          for (octave_idx_type i = 0; i < nr; i++)
-            {
-              octave_quit ();
-              result(i, j) = octave::math::max (a(i, j), b(i, j));
-            }
-        }
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = a(i, j) >= b(i, j) ? a(i, j)
+                           : (octave::math::isnan (a(i, j)) ? a(i, j)
+                              : b(i, j));
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::max (a(i, j), b(i, j));
+          }
     }
 
   return result;
diff --git a/liboctave/array/CMatrix.h b/liboctave/array/CMatrix.h
--- a/liboctave/array/CMatrix.h
+++ b/liboctave/array/CMatrix.h
@@ -443,15 +443,21 @@ extern OCTAVE_API ComplexMatrix operator
 extern OCTAVE_API ComplexMatrix operator * (const ComplexMatrix&,
                                             const ComplexMatrix&);
 
-extern OCTAVE_API ComplexMatrix min (const Complex& c, const ComplexMatrix& m);
-extern OCTAVE_API ComplexMatrix min (const ComplexMatrix& m, const Complex& c);
+extern OCTAVE_API ComplexMatrix min (const Complex& c, const ComplexMatrix& m,
+                                     bool includenan = false);
+extern OCTAVE_API ComplexMatrix min (const ComplexMatrix& m, const Complex& c,
+                                     bool includenan = false);
 extern OCTAVE_API ComplexMatrix min (const ComplexMatrix& a,
-                                     const ComplexMatrix& b);
+                                     const ComplexMatrix& b,
+                                     bool includenan = false);
 
-extern OCTAVE_API ComplexMatrix max (const Complex& c, const ComplexMatrix& m);
-extern OCTAVE_API ComplexMatrix max (const ComplexMatrix& m, const Complex& c);
+extern OCTAVE_API ComplexMatrix max (const Complex& c, const ComplexMatrix& m,
+                                     bool includenan = false);
+extern OCTAVE_API ComplexMatrix max (const ComplexMatrix& m, const Complex& c,
+                                     bool includenan = false);
 extern OCTAVE_API ComplexMatrix max (const ComplexMatrix& a,
-                                     const ComplexMatrix& b);
+                                     const ComplexMatrix& b,
+                                     bool includenan = false);
 
 extern OCTAVE_API ComplexMatrix linspace (const ComplexColumnVector& x1,
                                           const ComplexColumnVector& x2,
diff --git a/liboctave/array/CNDArray.cc b/liboctave/array/CNDArray.cc
--- a/liboctave/array/CNDArray.cc
+++ b/liboctave/array/CNDArray.cc
@@ -664,51 +664,61 @@ static const Complex Complex_NaN_result 
                                          octave::numeric_limits<double>::NaN ());
 
 ComplexNDArray
-ComplexNDArray::max (int dim) const
+ComplexNDArray::max (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<Complex> (*this, dim, mx_inline_max);
+  return do_mx_minmax_op<Complex> (*this, dim, mx_inline_max, includenan);
 }
 
 ComplexNDArray
-ComplexNDArray::max (Array<octave_idx_type>& idx_arg, int dim) const
+ComplexNDArray::max (Array<octave_idx_type>& idx_arg,
+                     int dim, bool includenan) const
 {
-  return do_mx_minmax_op<Complex> (*this, idx_arg, dim, mx_inline_max);
+  return do_mx_minmax_op<Complex> (*this, idx_arg, dim, mx_inline_max,
+                                   includenan);
 }
 
 ComplexNDArray
-ComplexNDArray::min (int dim) const
+ComplexNDArray::min (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<Complex> (*this, dim, mx_inline_min);
+  return do_mx_minmax_op<Complex> (*this, dim, mx_inline_min, includenan);
 }
 
 ComplexNDArray
-ComplexNDArray::min (Array<octave_idx_type>& idx_arg, int dim) const
+ComplexNDArray::min (Array<octave_idx_type>& idx_arg,
+                     int dim, bool includenan) const
 {
-  return do_mx_minmax_op<Complex> (*this, idx_arg, dim, mx_inline_min);
+  return do_mx_minmax_op<Complex> (*this, idx_arg, dim, mx_inline_min,
+                                   includenan);
 }
 
 ComplexNDArray
-ComplexNDArray::cummax (int dim) const
+ComplexNDArray::cummax (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<Complex> (*this, dim, mx_inline_cummax);
+  return do_mx_cumminmax_op<Complex> (*this, dim, mx_inline_cummax,
+                                      includenan);
 }
 
 ComplexNDArray
-ComplexNDArray::cummax (Array<octave_idx_type>& idx_arg, int dim) const
+ComplexNDArray::cummax (Array<octave_idx_type>& idx_arg,
+                        int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<Complex> (*this, idx_arg, dim, mx_inline_cummax);
+  return do_mx_cumminmax_op<Complex> (*this, idx_arg, dim, mx_inline_cummax,
+                                      includenan);
 }
 
 ComplexNDArray
-ComplexNDArray::cummin (int dim) const
+ComplexNDArray::cummin (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<Complex> (*this, dim, mx_inline_cummin);
+  return do_mx_cumminmax_op<Complex> (*this, dim, mx_inline_cummin,
+                                      includenan);
 }
 
 ComplexNDArray
-ComplexNDArray::cummin (Array<octave_idx_type>& idx_arg, int dim) const
+ComplexNDArray::cummin (Array<octave_idx_type>& idx_arg,
+                        int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<Complex> (*this, idx_arg, dim, mx_inline_cummin);
+  return do_mx_cumminmax_op<Complex> (*this, idx_arg, dim, mx_inline_cummin,
+                                      includenan);
 }
 
 NDArray
diff --git a/liboctave/array/CNDArray.h b/liboctave/array/CNDArray.h
--- a/liboctave/array/CNDArray.h
+++ b/liboctave/array/CNDArray.h
@@ -86,15 +86,19 @@ public:
   ComplexNDArray concat (const NDArray& rb,
                          const Array<octave_idx_type>& ra_idx);
 
-  ComplexNDArray max (int dim = -1) const;
-  ComplexNDArray max (Array<octave_idx_type>& index, int dim = -1) const;
-  ComplexNDArray min (int dim = -1) const;
-  ComplexNDArray min (Array<octave_idx_type>& index, int dim = -1) const;
+  ComplexNDArray max (int dim = -1, bool includenan = false) const;
+  ComplexNDArray max (Array<octave_idx_type>& index,
+                      int dim = -1, bool includenan = false) const;
+  ComplexNDArray min (int dim = -1, bool includenan = false) const;
+  ComplexNDArray min (Array<octave_idx_type>& index,
+                      int dim = -1, bool includenan = false) const;
 
-  ComplexNDArray cummax (int dim = -1) const;
-  ComplexNDArray cummax (Array<octave_idx_type>& index, int dim = -1) const;
-  ComplexNDArray cummin (int dim = -1) const;
-  ComplexNDArray cummin (Array<octave_idx_type>& index, int dim = -1) const;
+  ComplexNDArray cummax (int dim = -1, bool includenan = false) const;
+  ComplexNDArray cummax (Array<octave_idx_type>& index,
+                         int dim = -1, bool includenan = false) const;
+  ComplexNDArray cummin (int dim = -1, bool includenan = false) const;
+  ComplexNDArray cummin (Array<octave_idx_type>& index,
+                         int dim = -1, bool includenan = false) const;
 
   ComplexNDArray diff (octave_idx_type order = 1, int dim = -1) const;
 
diff --git a/liboctave/array/CSparse.cc b/liboctave/array/CSparse.cc
--- a/liboctave/array/CSparse.cc
+++ b/liboctave/array/CSparse.cc
@@ -184,14 +184,15 @@ static const Complex
                       octave::numeric_limits<double>::NaN ());
 
 SparseComplexMatrix
-SparseComplexMatrix::max (int dim) const
+SparseComplexMatrix::max (int dim, bool includenan) const
 {
   Array<octave_idx_type> dummy_idx;
-  return max (dummy_idx, dim);
+  return max (dummy_idx, dim, includenan);
 }
 
 SparseComplexMatrix
-SparseComplexMatrix::max (Array<octave_idx_type>& idx_arg, int dim) const
+SparseComplexMatrix::max (Array<octave_idx_type>& idx_arg,
+                          int dim, bool includenan) const
 {
   SparseComplexMatrix result;
   dim_vector dv = dims ();
@@ -217,8 +218,7 @@ SparseComplexMatrix::max (Array<octave_i
       octave_idx_type nel = 0;
       for (octave_idx_type j = 0; j < nc; j++)
         {
-          Complex tmp_max;
-          double abs_max = octave::numeric_limits<double>::NaN ();
+          Complex tmp_max = Complex_NaN_result;
           octave_idx_type idx_j = 0;
           for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
             {
@@ -229,30 +229,36 @@ SparseComplexMatrix::max (Array<octave_i
             }
 
           if (idx_j != nr)
-            {
-              tmp_max = 0.;
-              abs_max = 0.;
-            }
+            tmp_max = 0.;
 
           for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
             {
               Complex tmp = data (i);
 
               if (octave::math::isnan (tmp))
-                continue;
-
-              double abs_tmp = std::abs (tmp);
-
-              if (octave::math::isnan (abs_max) || abs_tmp > abs_max)
+                {
+                  if (includenan)
+                    {
+                      idx_j = ridx (i);
+                      tmp_max = tmp;
+                      break;
+                    }
+                  else
+                    continue;
+                }
+
+              if (octave::math::isnan (tmp_max) || tmp > tmp_max)
                 {
                   idx_j = ridx (i);
                   tmp_max = tmp;
-                  abs_max = abs_tmp;
-                }
-            }
-
-          idx_arg.elem (j) = octave::math::isnan (tmp_max) ? 0 : idx_j;
-          if (abs_max != 0.)
+                }
+            }
+
+          if (! includenan && octave::math::isnan (tmp_max))
+            idx_arg.elem (j) = 0;
+          else
+            idx_arg.elem (j) = idx_j;
+          if (tmp_max != 0.)
             nel++;
         }
 
@@ -299,10 +305,17 @@ SparseComplexMatrix::max (Array<octave_i
               octave_idx_type ir = ridx (i);
               octave_idx_type ix = idx_arg.elem (ir);
               Complex tmp = data (i);
-
-              if (octave::math::isnan (tmp))
+              Complex best = elem (ir, ix);
+
+              if (includenan)
+                {
+                  if (! octave::math::isnan (best)
+                      && (octave::math::isnan (tmp) || tmp > best))
+                    idx_arg.elem (ir) = j;
+                }
+              else if (octave::math::isnan (tmp))
                 continue;
-              else if (ix == -1 || std::abs (tmp) > std::abs (elem (ir, ix)))
+              else if (octave::math::isnan (best) || tmp > best)
                 idx_arg.elem (ir) = j;
             }
         }
@@ -341,14 +354,15 @@ SparseComplexMatrix::max (Array<octave_i
 }
 
 SparseComplexMatrix
-SparseComplexMatrix::min (int dim) const
+SparseComplexMatrix::min (int dim, bool includenan) const
 {
   Array<octave_idx_type> dummy_idx;
-  return min (dummy_idx, dim);
+  return min (dummy_idx, dim, includenan);
 }
 
 SparseComplexMatrix
-SparseComplexMatrix::min (Array<octave_idx_type>& idx_arg, int dim) const
+SparseComplexMatrix::min (Array<octave_idx_type>& idx_arg,
+                          int dim, bool includenan) const
 {
   SparseComplexMatrix result;
   dim_vector dv = dims ();
@@ -374,8 +388,7 @@ SparseComplexMatrix::min (Array<octave_i
       octave_idx_type nel = 0;
       for (octave_idx_type j = 0; j < nc; j++)
         {
-          Complex tmp_min;
-          double abs_min = octave::numeric_limits<double>::NaN ();
+          Complex tmp_min = Complex_NaN_result;
           octave_idx_type idx_j = 0;
           for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
             {
@@ -386,30 +399,36 @@ SparseComplexMatrix::min (Array<octave_i
             }
 
           if (idx_j != nr)
-            {
-              tmp_min = 0.;
-              abs_min = 0.;
-            }
+            tmp_min = 0.;
 
           for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
             {
               Complex tmp = data (i);
 
               if (octave::math::isnan (tmp))
-                continue;
-
-              double abs_tmp = std::abs (tmp);
-
-              if (octave::math::isnan (abs_min) || abs_tmp < abs_min)
+                {
+                  if (includenan)
+                    {
+                      idx_j = ridx (i);
+                      tmp_min = tmp;
+                      break;
+                    }
+                  else
+                    continue;
+                }
+
+              if (octave::math::isnan (tmp_min) || tmp < tmp_min)
                 {
                   idx_j = ridx (i);
                   tmp_min = tmp;
-                  abs_min = abs_tmp;
-                }
-            }
-
-          idx_arg.elem (j) = octave::math::isnan (tmp_min) ? 0 : idx_j;
-          if (abs_min != 0.)
+                }
+            }
+
+          if (! includenan && octave::math::isnan (tmp_min))
+            idx_arg.elem (j) = 0;
+          else
+            idx_arg.elem (j) = idx_j;
+          if (tmp_min != 0.)
             nel++;
         }
 
@@ -456,10 +475,17 @@ SparseComplexMatrix::min (Array<octave_i
               octave_idx_type ir = ridx (i);
               octave_idx_type ix = idx_arg.elem (ir);
               Complex tmp = data (i);
-
-              if (octave::math::isnan (tmp))
+              Complex best = elem (ir, ix);
+
+              if (includenan)
+                {
+                  if (! octave::math::isnan (best)
+                      && (octave::math::isnan (tmp) || tmp < best))
+                    idx_arg.elem (ir) = j;
+                }
+              else if (octave::math::isnan (tmp))
                 continue;
-              else if (ix == -1 || std::abs (tmp) < std::abs (elem (ir, ix)))
+              else if (octave::math::isnan (best) || tmp < best)
                 idx_arg.elem (ir) = j;
             }
         }
